(******************************************************************************)
(* (stripped) Modula-2 scanner                                                *)
(* (C) 2011..2012 Steffen Solyga <solyga@absinth.net>                         *)
(******************************************************************************)
DEFINITION MODULE Scnr;

IMPORT FIO;  (* debug only *)

TYPE
  TSymbol = (
    sNum,       (* has num *)
    sId, sLit,  (* have val *)
    sNot,
    sMul, sDiv, sAnd,                   (* mulop *)
    sPlus, sMinus, sOr,                 (* addop *)
    sEql, sNeq, sLss, sLeq, sGtr, sGeq, (* relop *)
    sLPar, sLBrk, sLBrc, sRBrc, sRBrk, sRPar,
    sCol, sBec, sBar, sSemi, sComma, sDot,
    sDef, sImpl, sFrgn, sMod, sFrom, sImport, sBeg, sEnd,
    sVar, sConst, sProc, sType,
    sInv, sEOF
  );
  TNumber = LONGCARD;
  TValue = CARDINAL;

  TPosDesc = RECORD
    l,c: CARDINAL;
  END;

VAR
  sym: TSymbol;
  num: TNumber;
  val: TValue;
  pos: TPosDesc;

PROCEDURE Put( s: ARRAY OF CHAR );
PROCEDURE Read();

PROCEDURE Keep();
PROCEDURE Diff( x, y: TValue ): INTEGER;

TYPE
  TModName = ARRAY [ 0 .. 15 ] OF CHAR;
  TPthName = ARRAY [ 0 .. 127 ] OF CHAR;

VAR
  mod: TModName; mdl: CARDINAL;
  def: BOOLEAN;
  pth: TPthName; ptl: CARDINAL;

PROCEDURE Open( v: TValue; def: BOOLEAN ): BOOLEAN;
PROCEDURE Close();

PROCEDURE Clear();

PROCEDURE PutPath( s: ARRAY OF CHAR );
VAR mocka: BOOLEAN;

PROCEDURE MkStr( VAR s: ARRAY OF CHAR; v: TValue ): CARDINAL; (* len *)

(* debug *)
PROCEDURE WrStr( v: TValue );
PROCEDURE WrAll();
PROCEDURE Dump();

END Scnr.
